﻿/*
 * ##############################################
 * KeyBoard-Form
 * Part of the QuickCalculator
 * ##############################################
 * 
 * You may copy and distribute this code and the 
 * whole program as you want.
 * This code is not meant to be sold.
 * 
 * Written by Philipp Erler
 * Contact me for feedback, new version or other causes:
 * ph.erler@gmx.net
 * 
 * Version info:
 * Last change: 2010 | 11 | 21
 * .net-Framework: V. 4.0
 * Microsoft Visual C# 2010 Express
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace QuickCalculator
{
    public partial class CalcKeyBoard : Form
    {
        public CalcKeyBoard()
        {
            InitializeComponent();
        }

        private void CalcKeyBoard_Load(object sender, EventArgs e)
        {
            butdez.Text = System.Globalization.CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator;
        }

        private void but0_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but0.Text));
        }

        private void but1_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but1.Text));
        }

        private void but2_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but2.Text));
        }

        private void but3_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but3.Text));
        }

        private void but4_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but4.Text));
        }

        private void but5_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but5.Text));
        }

        private void but6_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but6.Text));
        }

        private void but7_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but7.Text));
        }

        private void but8_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but8.Text));
        }

        private void but9_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.but9.Text));
        }

        private void butdez_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butdez.Text));
        }

        private void butsolve_Click(object sender, EventArgs e)
        {
            Program.frmMain.AcceptButton.PerformClick();
        }

        private void butplu_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butplu.Text));
        }

        private void butmin_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butmin.Text));
        }

        private void butmult_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butmult.Text));
        }

        private void butdiv_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butdiv.Text));
        }

        private void butans_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butans.Text));
        }

        private void butrand_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butrand.Text));
        }

        private void butabs_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butabs.Text));
        }

        private void butrnd_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butrnd.Text));
        }

        private void butpow_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butpow.Text));
        }

        private void butradic_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butradic.Text));
        }

        private void butlog_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butlog.Text));
        }

        private void butmod_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butmod.Text));
        }

        private void butsin_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butsin.Text));
        }

        private void butcos_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butcos.Text));
        }

        private void buttan_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.buttan.Text));
        }

        private void butasin_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butasin.Text));
        }

        private void butacos_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butacos.Text));
        }

        private void butatan_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butatan.Text));
        }

        private void buthsin_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.buthsin.Text));
        }

        private void buthcos_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.buthcos.Text));
        }

        private void buthtan_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.buthtan.Text));
        }

        private void butOpenBracket_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butOpenBracket.Text));
        }

        private void butCloseBracket_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(this.butCloseBracket.Text));
        }

        private void butspc_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(" "));
        }

        private void butunaryminus_Click(object sender, EventArgs e)
        {
            Program.frmMain.Insertion(this, new StringInsertionEventArgs("-"));
        }

        private void butNewVar_Click(object sender, EventArgs e)
        {
            //get highest xn
            int numVars = Program.CalcEngine.Get_Num_Vars();
            bool found;
            int highestNum = -1;
            //do until found something not used
            do
            {
                highestNum++;
                found = false;
                //check all vars
                for (int n = 0; n < numVars; n++)
                {
                    //print var
                    string varStr = Program.CalcEngine.Print_Var(n);
                    if (varStr.StartsWith("x"))
                    {
                        //get end of varName
                        int spacePos = varStr.IndexOf(' ');
                        if (spacePos > -1)
                        {
                            //separate number
                            string xNum = varStr.Substring(1, spacePos);
                            int xNumber;
                            try
                            {
                                //only "x2" or similar are valid
                                xNumber = System.Convert.ToInt32(xNum);
                                if (xNumber == highestNum)
                                {
                                    found = true;
                                    break;
                                }
                            }
                            catch (Exception)
                            {}
                        }
                    }

                }

            } while (found);

            //found a missing xn
            //insert new var name
            Program.frmMain.Insertion(this, new StringInsertionEventArgs("x" + highestNum + " = "));
        }

        private void butNewFct_Click(object sender, EventArgs e)
        {
            //get highest fn
            int numFcts = Program.CalcEngine.Get_Num_Functions();
            bool found;
            int highestNum = -1;
            //do until found something not used
            do
            {
                highestNum++;
                found = false;
                //check all fcts
                for (int n = 0; n < numFcts; n++)
                {
                    //print fct
                    string fctStr = Program.CalcEngine.Print_Function(n);
                    if (fctStr.StartsWith("f"))
                    {
                        //get end of fctName
                        int bracketPos = fctStr.IndexOf('(');
                        if (bracketPos > -1)
                        {
                            //separate number
                            string xNum = fctStr.Substring(1, bracketPos);
                            int xNumber;
                            try
                            {
                                //only "f2" out of "f2(x) = bla" or similar are valid
                                xNumber = System.Convert.ToInt32(xNum);
                                if (xNumber == highestNum)
                                {
                                    found = true;
                                    break;
                                }
                            }
                            catch (Exception)
                            { }
                        }
                    }

                }

            } while (found);

            //found a missing fn
            //insert new fct name
            Program.frmMain.Insertion(this, new StringInsertionEventArgs("f" + highestNum + "("));
        }

        private void CalcKeyBoard_Activated(object sender, EventArgs e)
        {
            Actualize_Vars_And_Functions();
        }

        //Actualize displayed variables and functions in the 2 listboxes
        private void Actualize_Vars_And_Functions()
        {
            //VARIABLES
            int numVars = Program.CalcEngine.Get_Num_Vars();

            //clear items
            lstVars.Items.Clear();

            //add items
            for (int i = 0; i <= numVars; i++)
            {
                string printVar = Program.CalcEngine.Print_Var(i);
                if (printVar == "")
                    break;
                lstVars.Items.Add(printVar);
            }

            //FUNCTIONS
            int numFcts = Program.CalcEngine.Get_Num_Functions();

            //clear items
            lstFcts.Items.Clear();

            //add items
            for (int i = 0; i <= numFcts; i++)
            {
                string printFct = Program.CalcEngine.Print_Function(i);
                if (printFct == "")
                    break;
                lstFcts.Items.Add(printFct);
            }
        }

        //add var name
        private void lstVars_SelectedIndexChanged(object sender, EventArgs e)
        {
            String copyString;
            try                                         //some errors occured when clicking on the empty listbox (items)
            {                                           //get varname
                copyString = lstVars.GetItemText(lstVars.SelectedItems[0]);
                int spacePos = copyString.IndexOf(' '); //remove "1: "
                copyString = copyString.Substring(spacePos + 1);
                spacePos = copyString.IndexOf(' ');     //remove value
                copyString = copyString.Remove(spacePos);
            }
            catch (Exception)
            { return; }

            lstVars.ClearSelected();
            //txtinput.Text 
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(copyString));
        }

        //add function name
        private void lstFcts_SelectedIndexChanged(object sender, EventArgs e)
        {
            String copyString;
            try                                                 //some errors occured when clicking on the empty listbox (items)
            {                                                   //get fctname
                copyString = lstFcts.GetItemText(lstFcts.SelectedItems[0]);
                int spacePos = copyString.IndexOf(' ');         //remove "1: "
                copyString = copyString.Remove(0, spacePos);
                int bracketPos = copyString.IndexOf('(');       //remove argument and expression
                copyString = copyString.Remove(bracketPos);
            }
            catch (Exception)
            { return; }

            lstFcts.ClearSelected();
            //txtinput.Text 
            Program.frmMain.Insertion(this, new StringInsertionEventArgs(copyString + '('));
        }
    }
}
