﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CalculationE
{
    public class OutputElement
    {
        public enum OutputType { ScriptMSG, ScriptInput, CalcInput, CalcOutput, ControlStructure, Error, Nothing };
        OutputType oType;
        string msg;

        public OutputElement(OutputType ioType, string imsg)
        {
            oType = ioType;
            msg = imsg;
        }

        public OutputType GetOutputType()
        {
            return oType;
        }

        public void GetOutputType(OutputType ioType)
        {
            oType = ioType;
        }

        public string GetMsg()
        {
            return msg;
        }

        public void SetMsg(string imsg)
        {
            msg = imsg;
        }

        override public string ToString()
        {
            return msg;
        }
    }
}
